//
//  RBTreeNode.hpp
//  RBTree
//
//  Created by 葉朝鈞 on 2021/4/4.
//  Copyright © 2021 葉朝鈞. All rights reserved.
//

#ifndef RBTreeNode_hpp
#define RBTreeNode_hpp

#include <stdio.h>

// 在2-3-4树模型下，黑色可理解为中间结点，红色为边缘结点
enum COLOR { RED, BLACK };

class RBTreeNode {
private:
    int key;
    COLOR color;
    RBTreeNode *l, *r, *p;
    
    void fixAfterInsertion(RBTreeNode *&root, int key, bool leaf);
    void fixAfterDeletion(RBTreeNode *&root, int key);
    
public:
    RBTreeNode(int key);
    RBTreeNode(int key, RBTreeNode *p);
    RBTreeNode(int key, COLOR color);
    void traverse();
    
    int maxKey();
    int minKey();
    
    void insert(RBTreeNode *&root, int k, bool leaf);
    void remove(RBTreeNode *&root, int k);
    
    void leftRotate();
    void rightRotate();
    
    int verify(int num);
    
    friend class RBTree;
};

#endif /* RBTreeNode_hpp */
